﻿;预定义部分
BUF EQU 6EH
MBF EQU 6FH
FBF EQU 70H
SBF EQU 71H
FGW EQU 76H
FSW EQU 77H
SGW EQU 78H
SSW EQU 79H
BYES BIT 00H ;0.5s 标志
S1 BIT P3.1
S0 BIT P3.0


;初始化及主程序
ORG 0000H
LJMP MAIN
ORG 000BH
LJMP INT_0              ;0.05s 中断服务程序
ORG 0100H
MAIN: MOV IE,#00H
MOV SP,#30H          ;堆栈指针
MOV 20H,#00H       ;清标志
CLR A ;A =00H
MOV BUF,A             ;BUF 清 0
MOV MBF,A             ;MBF 清 0
MOV FBF,#028H           ;FBF 清 0
MOV SBF,#07H     ;初始时钟显示 12:00
MOV TMOD,#01H  ;定时器 T0⼯作在⽅式 1
MOV TH0,#0B1H      ;T0⽤于时钟定时，0.02s 定时初值
MOV TL0,#0D0H
SETB PT0                ;T0⾼级优先- 4 -
ACALL FZ                ;调⽤向显示缓冲区放数⼦程序
ACALL XS                ;调⽤显示⼦程序
LCALL YS20MS
SETB EA                  ;开中断
SETB ET0
SETB TR0                ;启动定时
NOP
LOOP1: ACALL FZ     ;调⽤向显示缓冲区放数⼦程序
ACALL XS                 ;调⽤显示⼦程序
ACALL SM                ;调⽤键盘扫描处理⼦程序
SJMP LOOP1

;T0中断服务程序
INT_0:MOV TH0,#0B1H
MOV TL0,#0D0H
PUSH PSW
PUSH ACC
INC BUF ;BUF+1
MOV A,BUF
CJNE A,#25,INT_01
SETB BYES                            ;置位 0.5s 标志
INT_01:CJNE A,#50,DK13     ;累计 20次为 1s
CLR BYES                             ;清除 0.5s 标志
MOV BUF,#00H
MOV A,MBF                          ;修改秒计数单元
INC A
MOV MBF,A
CJNE A,#60,DK13                   ;不到 60，返回
MOV MBF,#00H                  ;等于 60，计数单元清 0
MOV A,FBF                       ;修改分计数单元
INC A
MOV FBF,A
CJNE A,#60,DK13
MOV FBF,#00H
MOV A,SBF                         ;修改时计数单元
INC A
MOV SBF,A
CJNE A,#24,DK13
MOV SBF,#00H
SJMP DK13
DK13: POP ACC
POP PSW
RETI

;向显示缓冲区放数字程序
FZ: PUSH PSW                       ;保护现场,(RS1,RS0)
PUSH B
PUSH ACC
FZ_1: MOV A,FBF                   ;FBF 中内容送⼊ A
ACALL CHU10                         ;调⽤除 10 程序
MOV SSW,B                           ;时个位送显缓 76H
MOV SGW,A                           ;时⼗位送显缓 77H
FZ_2: MOV A,SBF                    ;SBF 中内容送⼊ A
ACALL CHU10                          ;调⽤除 10 程序
MOV FGW,A                           ;分⼗位送显缓 79H
FZ_3: MOV FSW,B                    ;分个位送显缓 78H
FZ_4: POP ACC
POP B                                       ;恢复现场
POP PSW                                 ;恢复(RS1,RS0)
RET                                          ;⼦程序返回

;除 10⼦程序
CHU10:MOV B,#0AH
DIV AB
RET

;显示⼦程序(须将显缓中⼗进制数转换成七段码，再送数码显示器)
XS: PUSH PSW
SETB RS0                         ;转⼯作寄存器组 1
CLR RS1
PUSH ACC                      ;保护现场
MOV A,P2
ORL A,#0F0H                   ;⾼ 4位置 1
MOV P2,A                        ;关闭显示
MOV R0,#FGW
MOV DPTR,#TABD
MOV A,@R0
MOVC A,@A+DPTR
MOV P0,A
CLR P2.4                           ;点亮 1位
LCALL YS20MS
INC R0
MOV DPTR,#TABD
MOV A,@R0
MOVC A,@A+DPTR
JNB BYES,DISP_1
ANL A,#7FH                      ;点亮⼩数点
DISP_1:MOV P0,A
SETB P2.4
CLR P2.5                            ;点亮 2位
LCALL YS20MS
INC R0
MOV DPTR,#TABD
MOV A,@R0
MOVC A,@A+DPTR
MOV P0,A
SETB P2.5
CLR P2.6                               ;点亮 3位
LCALL YS20MS
INC R0
MOV DPTR,#TABD
MOV A,@R0
MOVC A,@A+DPTR
MOV P0,A
SETB P2.6
CLR P2.7                                ;点亮 4位
LCALL YS20MS
SETB P2.7
POP ACC                              ;恢复现场
POP PSW                              ;返回⼯作寄存器组
RET                                      ;⼦程序返回
TABD: DB 0C0H,0F9H,0A4H,0B0H,99H,92H,82H,0F8H,80H,90H,0FFH
 
;键扫描处理⼦程序
SM: JB S0,SM_3                      ;S1未按下转查 S2
ACALL DELY10                         ;延时消抖
JB S0,SM_3
SM_1: ACALL FZ
ACALL XS
JNB S0,SM_1                           ;等待 S1键释放
MOV A,SBF                              ;修改时计数缓冲单元
ADD A,#1
CJNE A,#24,SM_2                      ;是否等于 24
CLR A                                       ;等于 24时单元清 0
SM_2: MOV SBF,A                    ;保存结果
RET                                           ;返回
SM_3: JB S1,SM_6                   ;S2未按下转返回
ACALL DELY10
JB S1,SM_6
SM_4: ACALL FZ
ACALL XS
JNB S1,SM_4
MOV A,FBF
ADD A,#1
CJNE A,#60,SM_5
CLR A
SM_5: MOV FBF,A
SM_6: RET

;延时⼦程序
DELY10: MOV R6,#20
DEL2: MOV R7,#7DH
DEL1: NOP
NOP
DJNZ R7,DEL1
DJNZ R6,DEL2
RET
YS20MS:MOV R6,#06H
DL2: MOV R7,#100
DL1: NOP
NOP
DJNZ R7,DL1
DJNZ R6,DL2
RET
END